// =============== Klassen-Definition: intMATRIX  =======================================
// intMATRIX-Klasse fuer Matrizenoperationen vom Typ int
// (kann durch Template mit Klasse MATRIX vereinigt werden)
// Rechteckmatrix mat(i,j,k,l) wird spaltenweise gespeichert !!!
// Indizierung von i,j,k,l beginnt bei 0 !!!
// vgl. U. Breymann, C++, Carl Hanser Verlag 1993, S.186 ff
// ======================================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// experimentelles Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet
// Der Autor bernimmt keine Haftung fr Unvollstndigkeiten und Maengel der Algorithmen!
// Version:  5/1997
// Compiler: C++
// ================ Include-Files =======================================================
#include "pch.h"
#include "framework.h"
#include "MATRIXclass.h"
// ---------------------
// #include "intMatrix.h"
// ===========================================================================
// public -> Oeffentliche Mitgliedsfunktionen
// ===========================================================================
//
// Konstruktor -> intMATRIX mat(ni,nj,nk,nl)
// ======================================
// ni, nj, nk, nl: Dimensionen der 4D-Matrix
// -----------------------------------------
intMATRIX::intMATRIX(int ni,int nj,int nk,int nl)
{
//***cerr<<"intMATRIX::Konstruktor: neue Matrix erzeugen"<<'\n'; 
//
this->erzeugen(ni,nj,nk,nl);
};//--------------------------------------------------------------------------
//
// Konstruktor -> intMATRIX mat(C_array,ni,nj,nk,nl)
// =================================================
// C_array vorinitialisiert mittels Initialisierungsliste C_feld [] = { ... }
// ni, nj, nk, nl: Dimensionen der 4D-Matrix
// --------------------------------------------------------------------------
intMATRIX::intMATRIX(int* C_array, int ni, int nj, int nk, int nl)
{
//*** std::cerr<< "MATRIX::Konstruktor: neue Matrix erzeugen" << '\n';
//
this->erzeugen(ni,nj,nk,nl,1,C_array);
};
//---------------------------------------------------------------------------
//
// Kopier-Konstruktor (Matrix vollstaendig kopieren) -> intMATRIX mat1(&mat2)
// ==========================================================================
intMATRIX::intMATRIX(intMATRIX &mat2)
{
//***cerr<<"intMATRIX::Kopier-Konstruktor: Kopie von MATRIX erzeugen"<<'\n';
// 
// permanente Matrix
// =================
this->kopieren(mat2);
};//--------------------------------------------------------------------------
//
// Destruktor -> delete &mat
// =========================
intMATRIX::~intMATRIX(void)
{
//***cerr<<"intMATRIX::Destruktor: Matrix loeschen, typ= "<<typ<<'\n';
//
// Sperre gegen Loeschen beruecksichtigen
//
if(typ != 2)
{
if(typ != 0)
{
 if(matrix != NULL)
 { delete [] matrix;
   matrix=aktuelles_element=NULL;
 };
//***cerr<<"intMATRIX::Destruktor: Matrix-Inhalt geloescht"<<'\n';
};
//
typ=1;
dimi=dimj=dimk=diml=dimmax=0;
eintyp=0;
ia=ja=ka=la=0;
}
else
{
// Matrix darf nicht geloescht werden !!!
cout<<endl<<"intMATRIX::Destruktor: *** Programmierfehler des Anwenders ***"<<endl;
cout<<endl<<"                    Matrix darf nicht geloescht werden !!! "<<endl;
cout<<endl<<"***********************************************************"<<endl;
};
//***cerr<<"intMATRIX::Destruktor: Matrix-Deskriptor geloescht"<<'\n';
};//--------------------------------------------------------------------------
//
// Matrix gegen Loeschen sperren -> mat.sperren()
// ==============================================
void intMATRIX::sperren()
{
// permanente Matrix
if(typ == 1) typ=2;
};//--------------------------------------------------------------------------
//
// Matrix fuer Loeschen entsperren -> mat.entsperren()
// ===================================================
void intMATRIX::entsperren()
{
// permanente Matrix
if(typ == 2) typ=1;
};//--------------------------------------------------------------------------
//
// Temporaere Matrix loeschen, -> mat.temporaere_matrix_loeschen()
// ===============================================================
void intMATRIX::temporaere_matrix_loeschen()
{
if(typ < 1)
{
// Temporaere Matrix loeschen
// --------------------------
//***cerr<<"intMATRIX::temporaere_matrix_loeschen, typ= "<<typ<<'\n';
delete this;
//***cerr<<"intMATRIX: temporaere Matrix geloescht"<<'\n';
};
};//--------------------------------------------------------------------------
//
// WERT suchen
// ===========
// Argumente:
// knonr: Wert, nach dem gesucht wird
// ni,nj,nk,nl    : Dimensionslaengen der Matrix
//                : -1 Laenge automatisch ermitteln 
// di,dj,dk,dl    : Schrittweite, mit der die Matrix durchsucht wird
// Funktionsergebnis:  1 knonr wurde gefunden
//                    -1 knonr wurde nicht gefunden
int intMATRIX::wert_suchen(int knonr, int &i,int &j,int &k,int &l,
                     int ni,int di,int nj,int dj,int nk,int dk,int nl,int dl)
{
// Dimension ermitteln
int ii,jj,kk,ll,zi,zj,zk,zl;
//
this->dimension_ermitteln(zi,zj,zk,zl);
//
if(ni >= 0) zi=ni;
if(nj >= 0) zj=nj;
if(nk >= 0) zk=nk;
if(nl >= 0) zl=nl;  
//
int wert_intern=-1;
//
for(ll=0; ll<zl/dl; ll+=dl)
for(kk=0; kk<zk/dk; kk+=dk)
for(jj=0; jj<zj/dj; jj+=dj)
for(ii=0; ii<zi/di; ii+=di)
{
if(this->element(ii,jj,kk,ll) == knonr) {wert_intern=1; goto Ende;};
};
ii=jj=kk=ll=-1;
//
Ende:
i=ii; j=jj; k=kk; l=ll;
return wert_intern;
};//--------------------------------------------------------------------------
//============================================================================
// public -> Oeffentliche Mitgliedsfunktionen (mit temp. Matrizen !!!)
// ===========================================================================
//
// Typwandlungsoperator -> zahl=int(mat) (nur erstes Matrixelement zuweisen)
// ========================================
intMATRIX::operator int ()
{
int zahl;
zahl=*(this->matrix);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return zahl;
};//--------------------------------------------------------------------------
//
// Matrixindex -> (i)
// ==================
int &intMATRIX::operator () (int i)
{
// aktuelles Matrixelement notieren
aktuelles_element=this->adresse(i);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *aktuelles_element;
};//--------------------------------------------------------------------------
// Matrixindex -> (i,j)
// ====================
int &intMATRIX::operator () (int i,int j)
{
// aktuelles Matrixelement notieren
aktuelles_element=this->adresse(i,j);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *aktuelles_element;
};//--------------------------------------------------------------------------
// Matrixindex -> (i,j,k)
// ======================
int &intMATRIX::operator () (int i,int j,int k)
{
// aktuelles Matrixelement notieren
aktuelles_element=this->adresse(i,j,k);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *aktuelles_element;
};//--------------------------------------------------------------------------
//
// Matrixindex -> (i,j,k,l)
// ========================
int &intMATRIX::operator () (int i,int j,int k,int l)
{
// aktuelles Matrixelement notieren
aktuelles_element=this->adresse(i,j,k,l);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *aktuelles_element;
};//--------------------------------------------------------------------------
//
// Matrizenelement -> mat.element(i,j,k,l) vergleiche mat(i,j,k,l)
// ===============================================================
int &intMATRIX::element(int i,int j,int k,int l)
{
aktuelles_element=this->adresse(i,j,k,l);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *aktuelles_element;
};//--------------------------------------------------------------------------
//
// Aktuelles Matrixelement holen und den Elementzeiger inkrementieren
//                                                                    -> mat++
// ===========================================================================
// Durch den expliziten Aufruf -> mat.operator ++ (abstand)
//        kann der Elementzeiger auch um mehrere Elemente inkrementiert werden
// Der Elementzeiger wird nur vom Konstruktor, vom Destruktor
//                 und von den Operatoren operator (), operator -- veraendert!
// ---------------------------------------------------------------------------
int &intMATRIX::operator ++ (int abstand)
{
// Der Aufruf mat++ erfolgt ueber mat.operator ++ (0) -> Stroustrup, S. 338
if(abstand == 0) abstand=1;
//
// Aktuelles Matrixelement
int *matrix_aktuell=aktuelles_element;
//
// aktuelles Matrixelement inkrementieren
aktuelles_element+=abstand;
// Grenzen ueberpruefen

if(aktuelles_element < matrix)     aktuelles_element=matrix;
int *matrix_max=matrix+dimmax-1;
if(aktuelles_element > matrix_max) aktuelles_element=matrix_max;
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *matrix_aktuell;
};//--------------------------------------------------------------------------
//
// Aktuelles Matrixelement holen und den Elementzeiger dekrementieren
//                                                                   -> mat-- 
// ===========================================================================
// Durch den expliziten Aufruf -> mat.operator -- (abstand)
//        kann der Elementzeiger auch um mehrere Elemente dekrementiert werden
// Der Elementzeiger wird nur vom Konstruktor, vom Destruktor
//                und von den Operatoren operator (), operator ++ veraendert !
// ---------------------------------------------------------------------------
int &intMATRIX::operator -- (int abstand)
{
// Der Aufruf mat-- erfolgt ueber mat.operator -- (0) -> Stroustrup, S. 338
if(abstand == 0) abstand=1;
//
// Aktuelles Matrixelement
int *matrix_aktuell=aktuelles_element;
//
// aktuelles Matrixelement dekrementieren
aktuelles_element=aktuelles_element-abstand;
// Grenzen ueberpruefen
if(aktuelles_element < matrix)     aktuelles_element=matrix;
int *matrix_max=matrix+dimmax-1;
if(aktuelles_element > matrix_max) aktuelles_element=matrix_max;
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *matrix_aktuell;
};//--------------------------------------------------------------------------
//
// Matrix-Dimensionen temporaer aendern -> mat.dimension(i,j,k,l)
// ==============================================================
intMATRIX &intMATRIX::dimension(int ni,int nj,int nk,int nl)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,0);
// -----------------------------------------------
temp->dimension_temporaer(ni,nj,nk,nl);
// -----------------------------------------------
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Matrix-Dimensionen ermitteln -> mat.dimension_ermitteln(ni,nj,nk,nl)
// ====================================================================
// Ergebnis: dim=Anzahl der Matrixelemente (belegter Speicherplatz)
int intMATRIX::dimension_ermitteln(int &ni,int &nj,int &nk,int &nl)
{
ni=dimi; nj=dimj; nk=dimk; nl=diml;
//
return dimmax;
};//--------------------------------------------------------------------------
//
// Matrix-Dimensionen permanent aendern -> mat.dimension_aendern(i,j,k,l)
// ======================================================================
intMATRIX &intMATRIX::dimension_aendern(int ni,int nj,int nk,int nl)
{
int max=ni*nj*nk*nl;
if(max > dimmax)
{
cout<<"*** Fehler in Funktion intMATRIX::dimension_aendern -> Falsche Indizes:"<<'\n';
cout<<"dimmax="<<dimmax<<'\n';
cout<<"dimi="<<dimi<<" dimj="<<dimj<<" dimk="<<dimk<<" diml="<<diml<<'\n';
cout<<"  ni="<<  ni<<"   nj="<<  nj<<"   nk="<<  nk<<"   nl="<<  nl<<'\n';
cout<<"max   ="<<max<<'\n';
char c;
cin>>c;
};
// -----------------------------------
// Dimensionen aendern
dimi=ni;
dimj=nj;
dimk=nk;
diml=nl;
dimmax=max;
// -----------------------------------
return *this;    
};//--------------------------------------------------------------------------
//
// Anzahl der Zeilen/Spalten ermitteln -> mat.zeilen_spalten(ni,nj,nk,nl,dim)
// ==========================================================================
// Ergebnis: Anzahl der Zeilen/Spalten=sqrt(ni*nj*nk*nl)
//           von quadratischen Matrizen,
//           sonst -1
int intMATRIX::zeilen_spalten(int &ni,int &nj,int &nk,int &nl)
{
ni=dimi; nj=dimj; nk=dimk; nl=diml;
// Zeilen/Spalten von quadratischen Matrizen
int zeilen=dimi*dimj*dimk*diml;
double spalten=double(zeilen)+0.5;
spalten=sqrt(spalten);
int z=int(spalten);
//
if(z*z != zeilen) z=-1;
//
return z;
};//--------------------------------------------------------------------------
//
// Teilmatrix heraus -> ...=mat.teilmatrix_heraus(i,j, ni,nj, k,l, nk,nl)
// ======================================================================
intMATRIX &intMATRIX::teilmatrix_heraus(int i,int j, int ni,int nj,
                                      int k,int l, int nk,int nl)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(ni,nj,nk,nl);
// ----------------------------------------------------
temp->teil_heraus(*this,i,j,k,l);
// --------------------------------------------------
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Teilmatrix hinein -> mat.teilmatrix_hinein(i,j,k,l)=...
// =======================================================
intMATRIX &intMATRIX::teilmatrix_hinein(int i,int j,int k,int l)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,0);
// ------------------------------------------------
temp->teil_hinein(i,j,k,l);
// ------------------------------------------------
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Untermatrix heraus -> ...=mat.untermatrix_heraus(i,ni, j,nj, k,nk, l,nl)
// ========================================================================
intMATRIX &intMATRIX::untermatrix_heraus(int i,int ni, int j,int nj,
                                       int k,int nk, int l,int nl)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(ni,nj,nk,nl);
//-----------------------------------------------------
temp->unter_heraus(*this,i,j,k,l);
//-----------------------------------------------------
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Untermatrix hinein -> mat.untermatrix_hinein(i,j,k,l)=...
// =========================================================
intMATRIX &intMATRIX::untermatrix_hinein(int i,int j,int k,int l)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,0);
//-------------------------------------------------
temp->unter_hinein(i,j,k,l);
//-------------------------------------------------
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Matrix-Ausgabe -> cout<<mat
// ===========================
ostream &operator << (ostream &s,intMATRIX &mat)
{
char c;
// alte Zahlengenauigkeit retten
// -----------------------------
long alt_flags=cout.flags();
//
if(&s == &cout)
{
  // neue Zahlengenauigkeit setzen
  // -----------------------------
  cout.setf(ios::scientific);
//***  cout.setf(ios::fixed);
//***  cout.precision(2);
};
// -------------------------------------
mat.ausgeben(s);
// -------------------------------------
if(&s == &cout)
{
  // alte Zahlengenauigkeit
  // ----------------------
  cout.flags(alt_flags);
  // Pause
  // -----
  cout<<"Pause -> Zeichen eingeben:";
  // bel
  cout<<'\07';
  //
  // Abfrage auf return (Zeichen 10)
  int ret=cin.get(); ret=cin.peek(); 
  if(ret != 10) cin>>c;
};
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
mat.temporaere_matrix_loeschen();
//
return s;
};//--------------------------------------------------------------------------
//
// Matrix-Eingabe -> cin>>mat
// ==========================
istream &operator >> (istream &s,intMATRIX &mat)
{
// --------------------------------
mat.einlesen(s);
// --------------------------------
if(&s == &cin) {cout<<"Eingabe fertig !"<<'\n';};
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
mat.temporaere_matrix_loeschen();
//
return s;
};//--------------------------------------------------------------------------
//
// Alle Matrix-Elemente belegen -> mat =zahl
// =========================================
intMATRIX &intMATRIX::operator = (int zahl)
{
this->zuweisen(zahl,0);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *this;
};//--------------------------------------------------------------------------
//
// Alle Matrix-Elemente belegen -> mat+=zahl
// =========================================
intMATRIX &intMATRIX::operator += (int zahl)
{
this->zuweisen(zahl,2);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *this;
};//--------------------------------------------------------------------------
//
// Alle Matrix-Elemente belegen -> mat-=zahl
// =========================================
intMATRIX &intMATRIX::operator -= (int zahl)
{
this->zuweisen(zahl,4);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *this;
};//--------------------------------------------------------------------------
//
// Matrix zuweisen -> mat1 =mat2 (nur Matrizeninhalt kopieren)
// =============================
intMATRIX &intMATRIX::operator  = (intMATRIX &mat2)
{
this->zuweisen(mat2,0);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat2.temporaere_matrix_loeschen();
//
return *this;
};//---------------------------------------------------------------------------
//
// Matrix zuweisen -> mat1+=mat2 (nur Matrizeninhalt kopieren)
// =============================
intMATRIX &intMATRIX::operator += (intMATRIX &mat2)
{
this->zuweisen(mat2,2);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat2.temporaere_matrix_loeschen();
//
return *this;
};//--------------------------------------------------------------------------
//
// Matrix zuweisen -> mat1-=mat2 (nur Matrizeninhalt kopieren)
// =============================
intMATRIX &intMATRIX::operator -= (intMATRIX &mat2)
{
this->zuweisen(mat2,4);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat2.temporaere_matrix_loeschen();
//
return *this;
};//--------------------------------------------------------------------------
//
// positives Vorzeichen -> +mat
// ============================
intMATRIX &intMATRIX::operator + ()
{
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *this;
};//--------------------------------------------------------------------------
//
// Addition mit Skalar -> mat+zahl
// ===============================
intMATRIX &intMATRIX::operator + (int zahl)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,-1);
// -------------------------------------------------
for (int i=0; i<dimmax; i++)
{
*(temp->matrix+i)=*(matrix+i)+zahl;
};
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Addition mit Skalar -> zahl+mat
// ===============================
intMATRIX &operator + (int zahl,intMATRIX &mat)
{
return mat+zahl;
};//--------------------------------------------------------------------------
//
// Addition -> mat1+mat2 bzw. mat1+vek2 bzw. vek1+mat2
// ===================================================
intMATRIX &intMATRIX::operator + (intMATRIX &mat2)
{
// Zwischenspeicher temp
intMATRIX *temp;
// ------------ 
if (mat2.dimmax > this->dimmax)
temp=temporaere_matrix_erzeugen(mat2,-1);
// --------------------------------------
else
temp=temporaere_matrix_erzeugen(*this,-1);
// ---------------------------------------
//
temp->addieren(*this,mat2);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat2.temporaere_matrix_loeschen();
//
return *temp;
};//---------------------------------------------------------------------------
//
// negatives Vorzeichen -> -mat
// ============================
intMATRIX &intMATRIX::operator - ()
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,-1);
// -------------------------------------------------
for (int i=0; i<dimmax; i++)
{
*(temp->matrix+i)=-(*(matrix+i));
};
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Subtraktion mit Skalar -> mat-zahl
// ==================================
intMATRIX &intMATRIX::operator - (int zahl)
{
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,-1);
// -------------------------------------------------
for (int i=0; i<dimmax; i++)
{
*(temp->matrix+i)=*(matrix+i)-zahl;
};
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Subtraktion mit Skalar -> zahl-mat
// ==================================
intMATRIX &operator - (int zahl,intMATRIX &mat)
{
return -mat+zahl;
};//--------------------------------------------------------------------------
//
// Subtraktion -> mat1-mat2 bzw. mat1-vek2 bzw. vek1-mat2
// ======================================================
intMATRIX &intMATRIX::operator - (intMATRIX &mat2)
{
// Zwischenspeicher temp
intMATRIX *temp;
// ------------ 
if (mat2.dimmax > this->dimmax)
temp=temporaere_matrix_erzeugen(mat2,-1);
// --------------------------------------
else
temp=temporaere_matrix_erzeugen(*this,-1);
// ---------------------------------------
//
temp->subtrahieren(*this,mat2);
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
mat2.temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Multiplikation mit Skalar -> mat*zahl
// =====================================
intMATRIX &intMATRIX::operator * (int zahl)
{
//***cerr<<"MATRIX:: mat*zahl"<<'\n';
// Zwischenspeicher temp
intMATRIX *temp=temporaere_matrix_erzeugen(*this,-1);
// -------------------------------------------------
for (int i=0; i<dimmax; i++)
{
*(temp->matrix+i)=*(matrix+i)*zahl;
};
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
//
// Multiplikation mit Skalar -> zahl*mat
// =====================================
intMATRIX &operator * (int zahl,intMATRIX &mat)
{
//***cerr<<"MATRIX::zahl*mat"<<'\n';
return mat*zahl;
};//--------------------------------------------------------------------------
//
// Matrix transponieren -> mat.transponieren(index_0,index_1,index_2,index_3)
// ==========================================================================
intMATRIX &intMATRIX::transponieren(int index_0,int index_1,int index_2,
                                                                 int index_3)
{
// Indexfeld mit den zu vertauschenden Indizes
int findex[4];
// ----------
// Zwischenspeicher temp
intMATRIX *temp=new intMATRIX(*this,-1);
// -------------------------------
// Standardfall abfragen (vorbelegte Parameter -> Aufruf ohne Parameter)
if(index_0 == 2 && index_1 == 3 && index_2 == 0 && index_3 ==1)
{
// 2D-Matrizen
// ===========
//
if((dimi*dimj == 1) || (dimk*diml == 1))
  {index_0=1; index_1=0; index_2=3; index_3=2;}
else
if((dimi*dimk == 1) || (dimj*diml == 1))
  {index_0=2; index_1=3; index_2=0; index_3=1;} 
else
if((dimi*diml == 1) || (dimj*dimk == 1))
  {index_0=3; index_1=2; index_2=1; index_3=0;};
};
// ---------------------------------------------
//Dimensionen tauschen
findex[0]=dimi;              findex[1]=dimj;
findex[2]=dimk;              findex[3]=diml;
temp->dimi=findex[index_0];  temp->dimj=findex[index_1];
temp->dimk=findex[index_2];  temp->diml=findex[index_3];
// -----------------------------------------------------
int i,j,k,l;
//
for (l=0; l<diml; l++)
{ findex[3]=l;
  for (k=0; k<dimk; k++)
  { findex[2]=k;
    for (j=0; j<dimj; j++)
    { findex[1]=j;
      for (i=0; i<dimi; i++)
      { findex[0]=i;
     temp->matrix_element(findex[index_0],findex[index_1],findex[index_2],
                               findex[index_3])=this->matrix_element(i,j,k,l);
      };
    };
  };
};
//
// ggfls. temporaere Matrix loeschen, Original-Deskriptor wiederherstellen
this->temporaere_matrix_loeschen();
//
return *temp;
};//--------------------------------------------------------------------------
// ===========================================================================
// protected -> Geschuetzte Mitgliedsfunktionen
// ===========================================================================
//
// Adresse von Matrixelement -> mat.adresse(i,j,k,l)
// =================================================
int *intMATRIX::adresse(int i,int j,int k,int l)
{
int ijkl;
char c;
// Vektor-Index ermitteln
ijkl=this->index(i,j,k,l); 
// Fehler abfangen
// ---------------
if(ijkl >= dimmax)
{
cout<<"*** Fehler in Funktion intMATRIX::adresse -> Falscher Index:"<<'\n';
cout<<"dimmax="<<dimmax<<'\n';
cout<<"  ijkl="<<  ijkl<<'\n';
cin>>c;
return NULL;
}
//----------------
else
return this->matrix+ijkl;
};//--------------------------------------------------------------------------
//
// Matrixelement -> mat.matrix_element(i,j,k,l) vergleiche mat(i,j,k,l)
// ====================================================================
int &intMATRIX::matrix_element(int i,int j,int k,int l)
{
aktuelles_element=this->adresse(i,j,k,l);
return *aktuelles_element;
};//--------------------------------------------------------------------------
//
// Matrix erzeugen -> erzeugen(ni,nj,nk,nl,neutyp,C_array)
// =======================================================
// bei neutyp=-1 temporaere Matrix erzeugen
// bei neutyp= 1 permanente Matrix erzeugen
// C_array vorinitialisiertes C_Feld [] = { ... }
// ----------------------------------------------
void intMATRIX::erzeugen(int ni,int nj,int nk,int nl,int neutyp,int* C_array)
{
// Matrix-Deskriptor belegen und Speicher reservieren
// --------------------------------------------------
//***cerr<<"intMATRIX::erzeugen: neutyp= "<<neutyp<<'\n';
//
// Typ belegen
// -----------
if(neutyp == 0) typ=-1;
else            typ=neutyp;
//
// Vektor-Dimension belegen
// ------------------------
dimi=ni;
dimj=nj;
dimk=nk;
diml=nl;
dimmax=ni*nj*nk*nl;
//
// Speicher anfordern
// ------------------
// *** neu ************
if (C_array == NULL)
{
matrix=new int[dimmax];
//
// Matrix auf 0.0 setzen
// ---------------------
for (int i = 0; i < dimmax; i++) *(matrix + i) = 0;
}
else
matrix = C_array;
// ************************
//
// aktuelles Matrix-Element
// ------------------------
aktuelles_element=matrix;
//
// Anfangsindizes belegen
// ----------------------
ia=ja=ka=la=0;
//
// Typ des Einspeicherns belegen
// -----------------------------
eintyp=1;
};//--------------------------------------------------------------------------
//
// Matrix kopieren -> kopieren(&mat,neutyp)
// ========================================
// bei neutyp=-1 Matrix-Deskriptor, neuen Speicher anfordern (nur privat !!!)
// bei neutyp= 0 Matrix-Deskriptor, alten Speicher benutzen  (nur privat !!!)
// bei neutyp= 1 Matrix-Deskriptor, neuen Speicher anfordern, Matrix kopieren
// --------------------------------------------------------------------------
void intMATRIX::kopieren(intMATRIX &mat,int neutyp)
{
//***if(neutyp==-1) cerr<<"intMATRIX::kopieren: nur MATRIX-Deskriptor kopieren, neuen Speicher anfordern"<<'\n';
//***if(neutyp== 0) cerr<<"intMATRIX::kopieren: nur MATRIX-Deskriptor kopieren, alten Speicher benutzen"<<'\n';
//***if(neutyp>= 1) cerr<<"intMATRIX::kopieren: MATRIX-Deskriptor kopieren, neuen Speicher anfordern, Inhalt kopieren"<<'\n';
//
// Matrixtyp
typ=neutyp;
// Matrixdimensionen
dimi=mat.dimi;
dimj=mat.dimj;
dimk=mat.dimk;
diml=mat.diml;
// Vektor-Dimension
dimmax=mat.dimmax;
// Typ des Einspeicherns
eintyp=mat.eintyp;
// Anfangsindizes
ia=mat.ia;
ja=mat.ja;
ka=mat.ka;
la=mat.la;
//***cerr<<"intMATRIX::kopieren: Matrix-Deskriptor kopiert"<<'\n';
//
if(neutyp == 0)
{
// nur Matrix-Adresse kopieren
matrix=mat.matrix;
aktuelles_element=matrix;
//***cerr<<"intMATRIX::kopieren: Matrix-Adresse kopiert"<<'\n';
}
else
{
// neuen Speicher anfordern
matrix=new int[dimmax];
aktuelles_element=matrix; 
//***cerr<<"intMATRIX::kopieren: neuer Speicher angefordert"<<'\n';
};
//
if(neutyp >= 1)
{
// Matrix-Inhalt kopieren
for(int i=0; i<dimmax; i++)
{
*(matrix+i)=*(mat.matrix+i);
};
//***cerr<<"intMATRIX::kopieren: Matrix-Inhalt kopiert"<<'\n';
}
else
if(neutyp == -1)
{
// Matrix-Inhalt auf null setzen
for(int i=0; i<dimmax; i++)
{
*(matrix+i)=0;
};
//***cerr<<"intMATRIX::kopieren: Matrix-Inhalt = 0.0"<<'\n';
};
};//--------------------------------------------------------------------------
//
// temporaere Matrix erzeugen
//                          -> temporaere_matrix_erzeugen(ni,nj,nk,nl,neutyp)
// ===========================================================================
// bei neutyp=-1 temporaere Matrix erzeugen
// bei neutyp= 1 permanente Matrix erzeugen
// ni, nj, nk, nl: Dimensionen der 4D-Matrix
// -----------------------------------------
intMATRIX *intMATRIX::temporaere_matrix_erzeugen(int ni,int nj,int nk,int nl,
                                                                  int neutyp)
{
//***cerr<<"intMATRIX::temporaere_matrix_erzeugen: neue Matrix erzeugen"<<'\n'; 
//
intMATRIX *temp=new intMATRIX(ni,nj,nk,nl,neutyp);
//
return temp;
};//--------------------------------------------------------------------------
//
// temporaere Matrix als Kopie erzeugen
//                                 -> temporaere_matrix_erzeugen(&mat,neutyp)
// ===========================================================================
// Kopie der Matrix mat:
// bei neutyp=-1 Matrix-Deskriptor, neuen Speicher anfordern (nur privat !!!)
// bei neutyp= 0 Matrix-Deskriptor, alten Speicher benutzen  (nur privat !!!)
// bei neutyp= 1 Matrix-Deskriptor, neuen Speicher anfordern, Matrix kopieren
// --------------------------------------------------------------------------
intMATRIX *intMATRIX::temporaere_matrix_erzeugen(intMATRIX &mat,int neutyp)
{
//***cerr<<"intMATRIX::temporaere_matrix_erzeugen: Kopie erzeugen: neutyp= "<<neutyp<<'\n';
// 
intMATRIX *temp=new intMATRIX(mat,neutyp);
//
return temp;
};//--------------------------------------------------------------------------
//
// Matrix-Dimensionen temporaer aendern -> mat.dimension_temporaer(i,j,k,l)
// ========================================================================
void intMATRIX::dimension_temporaer(int ni,int nj,int nk,int nl)
{
char c;
int max,ijkl;
max=ni*nj*nk*nl;
if(max > dimmax)
{
cout<<"*** Fehler in Funktion intMATRIX::dimension_temporaer -> Falsche Indizes:"<<'\n';
cout<<"dimmax="<<dimmax<<'\n';
cout<<"dimi="<<dimi<<" dimj="<<dimj<<" dimk="<<dimk<<" diml="<<diml<<'\n';
cout<<"  ni="<<  ni<<"   nj="<<  nj<<"   nk="<<  nk<<"   nl="<<  nl<<'\n';
cout<<"max   ="<<max<<'\n';
cin>>c;
};
// -----------------------------------
// Anfangsindex in der Originalmatrix
if(eintyp != 1) ijkl=index(ia,ja,ka,la);
// -------------------------------------
// Dimensionen aendern
dimi=ni;
dimj=nj;
dimk=nk;
diml=nl;
dimmax=max;
// --------------
// Anfangsindizes in temporaerer Matrix aendern
if(eintyp != 1) index_4d(ijkl,ia,ja,ka,la);
};//--------------------------------------------------------------------------
//
// Teilmatrix heraus -> ...=mat1.teil_heraus(mat2, i,j,k,l)
// ========================================================
void intMATRIX::teil_heraus(intMATRIX &mat, int i,int j,int k,int l)
{
// Anfang der Teilmatrix
int anfang=mat.index(i,j,k,l);
// -----------------------------
// Anzahl der Matrixelemente
int ende=anfang+(this->dimi)*(this->dimj)*(this->dimk)*(this->diml);
if(ende > mat.dimmax) ende=mat.dimmax;
// -----------------------------------------
// Matrixelemente kopieren
int q=0;
for(int p=anfang; p<ende; p++)
{
*(this->matrix+q)=*(mat.matrix+p);
q++;
};
};//--------------------------------------------------------------------------
//
// Teilmatrix hinein -> mat.teil_hinein(i,j,k,l)=...
// =================================================
void intMATRIX::teil_hinein(int i,int j,int k,int l)
{
// Typ des Einspeicherns notieren
eintyp=0;
// Anfangsindizes notieren
ia=i;
ja=j;
ka=k;
la=l;
};//--------------------------------------------------------------------------
//
// Untermatrix heraus -> ...=mat1.unter_heraus(mat2, i,j,k,l)
// ==========================================================
void intMATRIX::unter_heraus(intMATRIX &mat, int i,int j,int k,int l)
{
int ii,jj,kk,ll;
//
for (ll=0; ll<diml; ll++)
{                                      // Anfang l
  for (kk=0; kk<dimk; kk++)
  {                                    // Anfang k
    for (jj=0; jj<dimj; jj++)
    {                                  // Anfang j
      for (ii=0; ii<dimi; ii++)
      {                                // Anfang i
         this->matrix_element(ii,jj,kk,ll)=
	                                mat.matrix_element(i+ii,j+jj,k+kk,l+ll);
      };                               // Ende i
    };                                 // Ende j
  };                                   // Ende k
};                                     // Ende l
};//--------------------------------------------------------------------------
//
// Untermatrix hinein -> mat.unter_hinein(i,j,k,l)=...
// ===================================================
void intMATRIX::unter_hinein(int i,int j,int k,int l)
{
// Typ des Einspeicherns notieren
eintyp=-1;
// Anfangsindizes notieren
ia=i;
ja=j;
ka=k;
la=l;
};//--------------------------------------------------------------------------
//
// Matrix-Ausgabe -> mat.ausgeben(s)
// =================================
void intMATRIX::ausgeben(ostream &s)
{
int const spalten=7;
int k,ek,ik,ei,i,dk,eik,ii,jj,kk,ll,dij,dkl;
// -----------------------------------------------
// Ueberschrift ausgeben
if(&s == &cout)
{
cout<<endl;
cout<<"[ ("<<dimi<<"*"<<dimj<<") * ("<<dimk<<"*"<<diml;
cout<<") ]-intMATRIX:";
cout<<endl;
};
// =====================================================================
// Matrix-Deskriptor fuer Testzwecke drucken
// -----------------------------------------
//***cerr<<"Adresse= "<<this<<'\n';
//***cerr<<"typ, dimi, dimj, dimk, diml, dimmax= "<<typ<<' '<<dimi<<' '<<
//***       dimj<<' '<<dimk<<' '<<diml<<' '<<dimmax<<'\n';
//***cerr<<"eintyp, ia, ja, ka, la, matrix, aktuelles_element= "<<eintyp<<' '<<ia<<' '<<
//***       ja<<' '<<ka<<' '<<la<<' '<<matrix<<' '<<aktuelles_element;
//***cerr<<'\n';
// =====================================================================
dkl=dimk*diml;
dij=dimi*dimj;
//
if(dkl == 1)
{
ek=dimj;
ei=dimi;
}
else
if(dij == 1)
{
ek=diml;
ei=dimk;
}
else
{
ek=dimk*diml;
ei=dimi*dimj;
};
//
for (k=0; k < ek; k+=spalten)
{
dk=k+spalten;
if (dk > ek) dk=ek;
if(&s == &cout) cout<<"Spalten "<<k<<" bis "<<dk-1<<'\n';
//*************************************************************
// 2D-Matrix mat(i, ik) ausgeben, Dimensionen mat(ni*nj, nk*nl)
//*************************************************************
  for (i=0; i < ei; i++)
  {
    eik=k+spalten;
    if(eik > ek) eik=ek;
// Indizes ii,jj aus i
    if(dkl == 1) goto Marke;
    if(dij == 1) goto Marke;
    index_2d(i, dimi,dimj, ii,jj);
//
Marke:
     for (ik=k; ik < eik; ik++)
     {
     // Feldbreite
     // ----------
     if(&s == &cout) cout.width(10);
     //-----------
if(dkl == 1)
{
    s<<matrix_element(i,ik,0,0)<<" ";
}
else
if(dij == 1)
{
    s<<matrix_element(0,0,i,ik);
}
else
{
// Indizes kk,ll aus ik berechnen
    index_2d(ik, dimk,diml, kk,ll);
//
    s<<matrix_element(ii,jj,kk,ll)<<" ";
};
    };

  s<<endl;
  };
if(dk != ek) s<<endl;
};
};//--------------------------------------------------------------------------
//
// Matrix-Eingabe -> mat.einlesen(s)
// =================================
void intMATRIX::einlesen(istream &s)
{
int i,j,k,l;
// ---------
if(&s == &cin)
{
  cout<<" [ ("<<dimi<<"*"<<dimj<<") * ("<<dimk<<"*"<<diml;
  cout<<") ]-intMATRIX (zeilenweise !!!) eingeben:";
  // bel, bel
  cout<<'\07'<<'\n';
};
// -------------------
for (i=0; i<dimi; i++)
for (j=0; j<dimj; j++)
for (k=0; k<dimk; k++)
for (l=0; l<diml; l++)
s>>matrix_element(i,j,k,l);
};//--------------------------------------------------------------------------
//
// Alle Matrix-Elemente belegen -> mat.zuweisen(zahl,zweig)
//                                 (nur Matrizeninhalt kopieren)
// =============================================================
// Zweig= 0 -> mat=    zahl
//      = 2 -> mat=mat+zahl
//      = 4 -> mat=mat-zahl
// ------------------------
void intMATRIX::zuweisen(int zahl,int zweig)
{
int i,k;
int *matrix1;
//
if(eintyp == -1)
  // Untermatrix
{
  if(zweig == 0) matrix_element(ia,ja,ka,la) =zahl;
    else
  if(zweig == 2) matrix_element(ia,ja,ka,la)+=zahl;
    else
  if(zweig == 4) matrix_element(ia,ja,ka,la)-=zahl;
  }
else
{
  // Matrix und Teilmatrix
  k=0;
  if(eintyp == 0) k=index(ia,ja,ka,la);
  matrix1=matrix+k;
  //
  if(zweig == 0) for (i=k; i<dimmax ;i++) *(matrix1++) =zahl;
  else
  if(zweig == 2) for (i=k; i<dimmax ;i++) *(matrix1++)+=zahl;
  else
  if(zweig == 4) for (i=k; i<dimmax ;i++) *(matrix1++)-=zahl;
};
};//--------------------------------------------------------------------------
//
// Matrix zuweisen -> mat1.zuweisen(mat2,zweig)
//                    (nur Matrizeninhalt kopieren)
// ================================================
// Zweig= 0 -> mat1=    mat2
//      = 2 -> mat1=mat+mat2
//      = 4 -> mat1=mat-mat2
void intMATRIX::zuweisen(intMATRIX &mat2,int zweig)
{
int i,j,k,l,dim;
int *matrix1,*matrix2;
//
if(eintyp == -1)
  // Untermatrix
{
  if(zweig == 0)
    for (l=0; l<mat2.diml; l++)
      for (k=0; k<mat2.dimk; k++)
        for (j=0; j<mat2.dimj; j++)
          for (i=0; i<mat2.dimi; i++)
              this->matrix_element(ia+i,ja+j,ka+k,la+l) =
		                                     mat2.matrix_element(i,j,k,l);
  else
  if(zweig == 2)
    for (l=0; l<mat2.diml; l++)
      for (k=0; k<mat2.dimk; k++)
        for (j=0; j<mat2.dimj; j++)
          for (i=0; i<mat2.dimi; i++)
              this->matrix_element(ia+i,ja+j,ka+k,la+l)+=
		                                     mat2.matrix_element(i,j,k,l);
  else
  if(zweig == 4)
    for (l=0; l<mat2.diml; l++)
      for (k=0; k<mat2.dimk; k++)
        for (j=0; j<mat2.dimj; j++)
          for (i=0; i<mat2.dimi; i++)
              this->matrix_element(ia+i,ja+j,ka+k,la+l)-=
		                                     mat2.matrix_element(i,j,k,l);
  }
else
{
  // Teilmatrix
  k=0;
  if(eintyp == 0) k=index(ia,ja,ka,la);
  // Einspeichern von Matrix und Teil-Matrix
// Indexgrenzen
  dim=dimmax-k;
  if(mat2.dimmax < dim) dim=mat2.dimmax;
  matrix1=matrix+k;
  matrix2=mat2.matrix;
  if(zweig == 0)
    for (matrix2=mat2.matrix; matrix2<mat2.matrix+dim ;matrix2++)
       *(matrix1++) =*matrix2;
  else
  if(zweig == 2)
    for (matrix2=mat2.matrix; matrix2<mat2.matrix+dim ;matrix2++)
       *(matrix1++)+=*matrix2;
  else
  if(zweig == 4)
    for (matrix2=mat2.matrix; matrix2<mat2.matrix+dim ;matrix2++)
       *(matrix1++)-=*matrix2;
};
};//--------------------------------------------------------------------------
//
// Addition -> mat1+mat2 bzw. mat1+vek2 bzw. vek1+mat2
// ===================================================
void intMATRIX::addieren(intMATRIX &mat1,intMATRIX &mat2)
{
int i,k,dim;
// ---------
if (mat2.dimmax > mat1.dimmax)
{
dim=mat2.dimmax;
// -------------
k=0;
for (i=0; i<dim; i++)
{
*(this->matrix+i)=*(mat1.matrix+k)+*(mat2.matrix+i);
k++;
if(k==mat1.dimmax) k=0;
};
}
else
{
dim=mat1.dimmax;
// -------------
k=0;
for (i=0; i<dim; i++)
{
*(this->matrix+i)=*(mat1.matrix+i)+*(mat2.matrix+k);
k++;
if(k==mat2.dimmax) k=0;
};
};
};//--------------------------------------------------------------------------
//
// Subtraktion -> mat1-mat2 bzw. mat1-vek2 bzw. vek1-mat2
// ======================================================
void intMATRIX::subtrahieren(intMATRIX &mat1,intMATRIX &mat2)
{
int i,k,dim;
// ---------
if (mat2.dimmax > mat1.dimmax)
{
dim=mat2.dimmax;
// -------------
k=0;
for (i=0; i<dim; i++)
{
*(this->matrix+i)=*(mat1.matrix+k)-*(mat2.matrix+i);
k++;
if(k==mat1.dimmax) k=0;
};
}
else
{
dim=mat1.dimmax;
// -------------
k=0;
for (i=0; i<dim; i++)
{
*(this->matrix+i)=*(mat1.matrix+i)-*(mat2.matrix+k);
k++;
if(k==mat2.dimmax) k=0;
};
};
};//--------------------------------------------------------------------------
// ===========================================================================
// private -> Private Mitgliedsfunktionen
// ===========================================================================
//
// Konstruktor -> intMATRIX mat(ni,nj,nk,nl,neutyp)
// ========================================================
// ni, nj, nk, nl: Dimensionen der 4D-Matrix
// bei neutyp=-1 temporaere Matrix erzeugen
// bei neutyp= 1 permanente Matrix erzeugen 
// ----------------------------------------
intMATRIX::intMATRIX(int ni,int nj,int nk,int nl,int neutyp)
{
//***cerr<<"Konstruktor: temporaere MATRIX erzeugen, neutyp= "<<neutyp<<'\n'; 
//
this->erzeugen(ni,nj,nk,nl,neutyp);
};//--------------------------------------------------------------------------
//
// Kopier-Konstruktor -> intMATRIX mat1(&mat2,neutyp)
// ===============================================
// bei neutyp=-1 Matrix-Deskriptor, neuen Speicher anfordern (nur privat !!!)
// bei neutyp= 0 Matrix-Deskriptor, alten Speicher benutzen  (nur privat !!!)
// bei neutyp= 1 Matrix-Deskriptor, neuen Speicher anfordern, Matrix kopieren
// --------------------------------------------------------------------------
intMATRIX::intMATRIX(intMATRIX &mat2,int neutyp)
{
//***cerr<<"intMATRIX::Kopier-Konstruktor: Kopie von MATRIX erzeugen, neutyp= "<<neutyp<<'\n';
// 
// permanente Matrix
// =================
this->kopieren(mat2,neutyp);
};//--------------------------------------------------------------------------
//
// Index ijkl von Matrixelement -> mat.index(i,j,k,l)
// ==================================================
int intMATRIX::index(int i, int j, int k, int l)
{
char c;
int ijkl;
// Fehler abfangen
// ---------------
ijkl=i+dimi*(j+dimj*(k+dimk*l));
if(ijkl >= dimmax)
{
cout<<"*** Fehler in Funktion intMATRIX::index -> Falsche Indizes:"<<'\n';
cout<<"dimmax="<<dimmax<<'\n';
cout<<"dimi="<<dimi<<" dimj="<<dimj<<" dimk="<<dimk<<" diml="<<diml<<'\n';
cout<<"   i="<<   i<<"    j="<<   j<<"    k="<<   k<<"    l="<<   l<<'\n';
cout<<"  ijkl="<<  ijkl<<'\n';
cin>>c;
return 0;
}
//----------------
else
return ijkl;
};//--------------------------------------------------------------------------
//
// 2D-Indizes von Matrizenelement -> mat.index_2d(ij, dimi,dimj, i,j)
// ==================================================================
void intMATRIX::index_2d(int ij,int dimi,int dimj,int &i,int &j)
{
int k;
index_3d(ij,dimi,dimj,1, i,j,k);
};//--------------------------------------------------------------------------
//
// 3D-Indizes von Matrizenelement -> mat.index_3d(ijk, dimi,dimj,dimk, i,j,k)
// ==========================================================================
void intMATRIX::index_3d(int ijk,int dimi,int dimj,int dimk,
                                                        int &i,int &j,int &k)
{
char c;
int n2=dimi*dimj;
// ---------------
// k=ijk/(ni*nj)
k=ijk/n2;
// j=ijk/ni-k*nj
n2=k*dimj;
j=ijk/dimi-n2;
// i=ijk-(k*nj+j)*ni
i=ijk-(n2+j)*dimi;
//
// Fehler abfangen
if( (i >= dimi) || (j >= dimj) || (k >= dimk) )
{
cout<<" *** Fehler in Funktion intMATRIX::index_3d -> Falsche Indizes:"<<'\n';
cout<<"ijk= "<<ijk;
cout<<"dimi= "<<dimi<<" dimj= "<<dimj<<" dimk= "<<dimk<<'\n';
cout<<"   i= "<<   i<<"    j= "<<   j<<"    k= "<<   k<<'\n';
i=j=k=0;
cin>>c;
};
};//--------------------------------------------------------------------------
//
// 4D-Indizes von Matrizenelement -> mat.index_4d(ijkl, i,j,k,l)
// =============================================================
void intMATRIX::index_4d(int ijkl,int &i,int &j,int &k,int &l)
//
{
char c;
int n2=dimi*dimj;
int n3=n2*dimk;
// ---------------
// l=ijkl/(ni*nj*nk)
l=ijkl/n3;
// k=ijkl/(ni*nj)-l*nk
n3=l*dimk;
k=ijkl/n2-n3;
// j=ijkl/ni-(l*nk+k)*nj
n2=(n3+k)*dimj;
j=ijkl/dimi-n2;
// i=ijkl-((l*nk+k)*nj+j)*ni
i=ijkl-(n2+j)*dimi;
//
// Fehler abfangen
if( (i >= dimi) || (j >= dimj) || (k >= dimk) || (l >= diml) )
{
cout<<" *** Fehler in Funktion intMATRIX::index_4d -> Falsche Indizes:"<<'\n';
cout<<"ijkl= "<<ijkl<<'\n';
cout<<"dimi= "<<dimi<<" dimj= "<<dimj<<" dimk= "<<dimk<<" diml= "<<diml<<'\n';
cout<<"   i= "<<   i<<"    j= "<<   j<<"    k= "<<   k<<"    l= "<<   l<<'\n';
i=j=k=l=0;
cin>>c;
};
};
// ======================================================================================
